Imports Microsoft.VisualBasic
Imports System.ComponentModel.DataAnnotations

Namespace DataFormTest
	Public NotInheritable Class EmployeeValidator
		Private Sub New()
		End Sub
		Public Shared Function ValidateEmployee(ByVal emp As Employee) As ValidationResult
			Dim memberNames() As String = { "Age", "AnnualSalary" }
			If emp.Age >= 50 AndAlso emp.AnnualSalary < 50000 Then
				Return New ValidationResult("Employee is over 50 and must make more than $50,000.", memberNames)
			Else
				Return ValidationResult.Success
			End If
		End Function

		Public Shared Function ValidateAge(ByVal age As Integer) As ValidationResult
			If age > 150 Then
				Return New ValidationResult("Employee's age must be under 150.")
			ElseIf age <= 0 Then
				Return New ValidationResult("Employee's age must be greater than 0.")
			Else
				Return ValidationResult.Success
			End If
		End Function
	End Class
End Namespace