Imports Microsoft.VisualBasic
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations

Namespace DataFormTest
	Public MustInherit Class ModelBase
		Implements INotifyPropertyChanged, IEditableObject
		Private privatevalidationResults As List(Of ValidationResult)
		Private Property validationResults() As List(Of ValidationResult)
			Get
				Return privatevalidationResults
			End Get
			Set(ByVal value As List(Of ValidationResult))
				privatevalidationResults = value
			End Set
		End Property

		Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
		Protected Sub FirePropertyChanged(ByVal propertyname As String)
			Dim handler = PropertyChangedEvent
			If handler IsNot Nothing Then
				handler(Me, New PropertyChangedEventArgs(propertyname))
			End If
		End Sub

		Protected Sub Validate(ByVal value As Object, ByVal propertyName As String)
			Validator.ValidateProperty(value, New ValidationContext(Me, Nothing, Nothing) With {.MemberName = propertyName})
		End Sub

		Public Function IsValid() As Boolean
			Return Validator.TryValidateObject(Me, New ValidationContext(Me, Nothing, Nothing), Me.validationResults, True)
		End Function

		#Region "Implementation of IEditableObject"

		Public MustOverride Sub BeginEdit() Implements IEditableObject.BeginEdit
		Public MustOverride Sub EndEdit() Implements IEditableObject.EndEdit
		Public MustOverride Sub CancelEdit() Implements IEditableObject.CancelEdit

		#End Region
	End Class
End Namespace